//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//############################################################################
//# HISTORY  gps_nmea.h
//#
//# 26.06.2014 OG - NEU
//############################################################################


#ifndef GPS_NMEA_H_
#define GPS_NMEA_H_


//---------------------------------
//---------------------------------
typedef struct
{
    uint32_t Counter;                   // Zaehler empfangene GPGGA Pakete
    int32_t  Latitude;                  // in 1E-7 deg
    int32_t  Longitude;                 // in 1E-7 deg
    int16_t  Altitude;                  // Hoehe in Meter
    uint8_t  SatFix;                    // GPS Quality indicator (0=no fix, 1=GPS fix, 2=Dif. GPS fix, 6=Estimated)
    uint8_t  SatsInUse;                 // Number of satelites currently in use
    int16_t  HDOP;                      // Horizontal Dilution of Precision, 1.1 -xx.x, niederiger = besser
    char     Time[9];                   // "hh:mm:ss"
} NMEA_GPGGA_t;


//---------------------------------
// GPS_Pos_t
// definiert in: mk_data-stucts.h
//---------------------------------
// typedef struct
// {
//     s32 Longitude;      // in 1E-7 deg
//     s32 Latitude;       // in 1E-7 deg
//     s32 Altitude;       // in mm
//     u8 Status;          // validity of data
// } __attribute__((packed)) GPS_Pos_t;



//---------------------------------
// export vars
//---------------------------------
extern NMEA_GPGGA_t     NMEA;
extern uint8_t receiveNMEA;


//---------------------------------
// export func
//---------------------------------
volatile uint8_t NMEA_receiveBT( void );
void NMEA_GetNewData( void );


#endif // #define GPS_NMEA_H_
