/*****************************************************************************
 *   Copyright (C) 2008 Thomas Kaiser, thomas@ft-fanpage.de                  *
 *   Copyright (C) 2009 Peter "woggle" Mack, mac@denich.net                  *
 *   Copyright (C) 2011 Christian "Cebra" Brandtner, brandtner@brandtner.net *
 *   Copyright (C) 2011 Harald Bongartz                                      *
 *                                                                           *
 *   This program is free software; you can redistribute it and/or modify    *
 *   it under the terms of the GNU General Public License as published by    *
 *   the Free Software Foundation; either version 2 of the License.          *
 *                                                                           *
 *   This program is distributed in the hope that it will be useful,         *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
 *   GNU General Public License for more details.                            *
 *                                                                           *
 *   You should have received a copy of the GNU General Public License       *
 *   along with this program; if not, write to the                           *
 *   Free Software Foundation, Inc.,                                         *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.               *
 *                                                                           *
 *                                                                           *
 *   Credits to:                                                             *
 *   Holger Buss & Ingo Busker from mikrokopter.de for the MK project + SVN  *
 *                          http://www.mikrokopter.de                        *
 *   Gregor "killagreg" Stobrawa for his version of the MK code              *
 *   Thomas Kaiser "thkais" for the original project. See                    *
 *                          http://www.ft-fanpage.de/mikrokopter/            *
 *                          http://forum.mikrokopter.de/topic-4061-1.html    *
 *   Claas Anders "CaScAdE" Rathje for providing the font and his C-OSD code *
 *                          http://www.mylifesucks.de/oss/c-osd/             *
 *   Harald Bongartz "HaraldB" for providing his Ideas and Code for usibility*
 *****************************************************************************/
//############################################################################
//# HISTORY  parameter_names.h
//#
//#
//# 21.10.2013 Cebra
//# - add: #define MKVERSION201a und Erweiterung der Parametermens
//#
//# 30.05.2013 Cebra
//# - add: #define MKVERSION091a und Erweiterung der Parametermens
//#
//# 13.05.2013 Cebra
//# - add: #define MKVERSION090h    // wegen GPS-Zeitausgabe NC
//#
//# 03.04.2013 Cebra
//# - chg: Hollndische Mentexte
//############################################################################

#define PAGES 14

#if defined MKVERSION088n
#define PARAM_COUNT 152  //152 FC088L
#elif defined MKVERSION090b
#define PARAM_COUNT 156 //156 FC090b
#elif defined MKVERSION090e || defined MKVERSION090h
#define PARAM_COUNT 156 //156 FC090b
#elif defined MKVERSION091a
#define PARAM_COUNT 158 //158 FC091a
#elif defined MKVERSION091f
#define PARAM_COUNT 158 //158 FC091a
#elif defined MKVERSION201a
#define PARAM_COUNT 159 //159 FC201a
#elif defined MKVERSION201f
#define PARAM_COUNT 162 //161 FC201f

#else
#error "Fehlende Definition"
#endif

#define PARAM_LENGTH 15
#define PARAM_NUM_LANG 3

//           German          Englisch    Hollndisch

const char param_pages[PAGES][PARAM_NUM_LANG][PARAM_LENGTH] PROGMEM= // zeilen,zeichen+1
{
	{"Kanle        ","Channel       ","Kanaal        "},
	{"Konfiguration ","main          ","Configuratie  "},
	{"Stick         ","stick         ","Stick         "},
	{"Looping       ","Looping       ","Looping       "},
	{"Hhe          ","Altitude      ","Hoogte        "},
	{"Kamera        ","Camera        ","Camera        "},
	{"NaviCtrl      ","NaviCtrl      ","NaviCtrl      "},
	{"Ausgnge      ","Outputs       ","Uitgangen     "},
	{"Verschiedenes ","Divers        ","Diversen      "},
	{"Gyro          ","Gyro          ","Gyro          "},
	{"Benutzer      ","User          ","Gebruiker     "},
	{"Achskopplung  ","Coupl Axes    ","Koppeling Ass "},
	{"Mixer-Setup   ","Config Mix    ","Config. Mixer "},
	{"Easy Setup    ","Config Easy   ","Config. easy  "},



};


//Namen
const char  param_names[PARAM_COUNT][PARAM_NUM_LANG][PARAM_LENGTH] PROGMEM=
{
	// group 0 (kanaele) 1-15

	{"Gas           ","Throttle      ","Gas           "},
	{"Gier          ","Gier          ","Gier          "},
	{"Nick          ","Nick          ","Nick          "},
	{"Roll          ","Roll          ","Roll          "},
	{"Poti 1        ","Poti 1        ","Poti 1        "},
	{"Poti 2        ","Poti 2        ","Poti 2        "},
	{"Poti 3        ","Poti 3        ","Poti 3        "},
	{"Poti 4        ","Poti 4        ","Poti 4        "},
	{"Poti 5        ","Poti 5        ","Poti 5        "},
	{"Poti 6        ","Poti 6        ","Poti 6        "},
	{"Poti 7        ","Poti 7        ","Poti 7        "},
	{"Poti 8        ","Poti 8        ","Poti 8        "},
	{"Motor Sich.Sch","Mot.Safety Sw.","Mot.saf.schak."},
	{"Motor Swi.Mode","Motor Swi.Mode","Motor Swi.Mode"},
	{"Erw. Sig. Pr. ","Enh. Sig.Check","Uitg.Sig.Check"},
	{"Empfnger Typ ","Receiver Type ","Ontvang. Type "},
#if defined MKVERSION090b
	{"Spk all Events","Spk all Events","Spreek alles  "},
#elif defined MKVERSION090e || defined MKVERSION090h || defined MKVERSION091a || defined MKVERSION091f || defined MKVERSION201a || defined MKVERSION201f
        {"Spk all Events","Spk all Events","Spreek alles  "},
#elif defined MKVERSION088n
#else
#error "Fehlende Definition"
#endif
	// group 1 (main) 16-23

	{"Hhenregeler  ","Ctrl Altitude ","Ctrl Hoogte   "},
	{"GPS           ","GPS           ","GPS           "},
	{"Kompass       ","Compass       ","Kompas        "},
	{"KompFest Ausr.","CompOrient.Fix","Kompas vast   "},
	{"Erw. Sig. Pr. ","Sens.RcvSigVal","ExtRec Signaal"},
	{"Achs(e.)koppl.","Axis Couping  ","As koppeling  "},
	{"Drehratenbegr.","RotRate limit.","RotRate limit."},
	{"Heading Hold  ","Nick/Roll     ","Koers vast    "},


	// group 2 (stick) 24-27

	{"Nick/Roll P   ","Nick/Roll P   ","Nick/Roll P   "},
	{"Nick/Roll D   ","Nick/Roll D   ","Nick/Roll D   "},
	{"Gier P        ","Gier P        ","Gier P        "},
	{"Externe Kontr.","Extern Ctrl   ","Extern Control"},


	// group3 : (looping) 28-36

	{"Looping oben  ","Looping up    ","Looping omhoog"},
	{"Looping unten ","Looping down  ","Looping bened."},
	{"Looping links ","Looping left  ","Looping links "},
	{"Looping rechts","Looping right ","Looping rechts"},
	{"Gas Limit     ","Throttle Limit","Gas Limiet    "},
	{"Ansprechschw. ","Resp. Thresh. ","Drempelwaarde "},
	{"Hysterese     ","Hysteresis    ","Hysterese     "},
	{"Umkehrp. Nick ","Turnover Nick ","Nick geinvert."},
	{"Umkehrp. Roll ","Turnover Roll ","Roll geinvert."},


	// group 4 (hoehe) 37-50

	{"Hhenregelung ","Altitude Ctrl ","Hoogte Control"},
	{"J:HBeg,N:Vario","Y:LimH,N:Vario","Y:LimH,N:Vario"},
	{"Schalter f. H.","use Sw. f.Setp","Schak. Hoogte "},
	{"akust. Vario  ","acoustic Vario","Akoest. Vario "},
	{"Sollhhe      ","Setpoint      ","Gewenste hoogt"},
	{"Min. Gas      ","min. throttle ","Minimaal gas  "},
	{"Hhe P        ","Altitude P    ","Hoogte P      "},
	{"Luftdruck D   ","Barometric D  ","Barometr. D   "},
	{"Z-ACC         ","ACC Z         ","ACC Z         "},
	{"Max. Hhe     ","Max. Altitude ","Max. hoogte   "},
	{"Verstrkung/R ","gain/rate     ","Verst./rate   "},
	{"Schwebegas +/-","hoover varia. ","hoover varia. "},
	{"GPS Z         ","GPS Z         ","GPS Z         "},
	{"Stick Neutr. P","stick neutr. P","Stick neutr. P"},
#if defined MKVERSION091a || defined MKVERSION091f || defined MKVERSION201a || defined MKVERSION201f
        {"Auto S/L Chan.","Auto S/L Chan.","Auto S/L Chan."},
        {"Lande Geschwi.","landing speed ","landing speed "},

#elif defined MKVERSION090e || defined MKVERSION090h || defined MKVERSION090b || defined MKVERSION201a || defined MKVERSION201f

#elif defined MKVERSION088n
#else
#error "Fehlende Definition"
#endif



	// group 5 : (kamera) 51-68

	{"Nick S. Anst. ","nick serv ctrl","nick serv ctrl"},
	{"Nick Kompens. ","nick compens. ","nick compens. "},
#if defined MKVERSION201a || defined MKVERSION201f
	{"Compens.  aus ","Compens.  off ","Compens.  off "},
#endif
	{"Nick Umkehren ","nick inv. dir.","nick inv.rich."},
#if defined MKVERSION090b
	{"Nick Servo rel","nick servo rel","nick servo rel"},
#elif defined MKVERSION090e || defined MKVERSION090h || defined MKVERSION091a || defined MKVERSION091f || defined MKVERSION201a || defined MKVERSION201f
        {"Nick Servo rel","nick servo rel","nick servo rel"},
#elif defined MKVERSION088n
#else
#error "Fehlende Definition"
#endif
	{"Nick Servo min","nick servo min","nick servo min"},
	{"Nick Servo max","nick servo max","nick servo max"},
	{"Nick Serv Filt","Nick Serv Filt","Nick Serv Filt"},  //FC0.87

	{"Roll S. Anst. ","roll serv ctrl","roll serv ctrl"},
	{"Roll Kompens. ","roll compens. ","roll compens. "},
	{"Roll Umkehren ","roll inv. dir.","roll omkeren  "},
	{"Roll Servo min","roll servo min","roll servo min"},
	{"Roll Servo max","roll servo max","roll servo max"},
	{"Roll Serv Filt","Roll Serv Filt","Roll Serv Filt"},  //FC0.87

	{"Anst. Geschw. ","servo refresh ","Servo refresh "},
	{"Manuelle Gesch","manuell Speed ","Snelh.handbed."},
	{"Cam Richtung  ","Cam Orient    ","Camera richt. "},
	{"Servo 3       ","Servo 3       ","Servo 3       "},
	{"Servo 4       ","Servo 4       ","Servo 4       "},
	{"Servo 5       ","Servo 5       ","Servo 5       "},

                                                    
	// group 6 : (navictrl) 69-88                      "CH Hoogte     "

	{"GPS           ","enable GPS    ","enable GPS    "},
	{"GPS Modus St. ","GPS mode contr","GPS mode contr"},
	{"GPS Verstrk. ","GPS Gain      ","GPS versterk. "},
	{"GPS St. Schw. ","GPS stick thre","GPS st. dremp."},
	{"Min. Sat.     ","Min. Sat.     ","Min. Sat.     "},
	{"GPS-P         ","GPS-P         ","GPS-P         "},
	{"GPS-I         ","GPS-I         ","GPS-I         "},
	{"GPS-D         ","GPS-D         ","GPS-D         "},
	{"P Limit       ","Limit  P      ","Limiet  P     "},
	{"I Limit       ","Limit  I      ","Limiet  I     "},
	{"D Limit       ","Limit  D      ","Limiet  D     "},
	{"GPS Acc       ","GPS Acc       ","GPS Acc       "},
	{"GPS Windkorr. ","GPS Wind Corr.","GPS Wind Corr."},
	{"Bremswirkung  ","Speed compens.","Remwerking    "},
	{"GPS max. Rad. ","GPS max.radius","GPS max.radius"},
	{"GPS Winkel Li.","GPS angl.limit","GPS hoek lim. "},
	{"PH Login time ","PH login time ","PH login tijd "},
	{"Dynamic PH    ","Dynamic PH    ","Dynamische PH "},
	{"GPS m. Rad dPH","GPS m. Rad dPH","GPS m. Rad dPH"}, //FC0.87
	{"CH Hhe       ","CH Altitude   ","CH Hoogte     "},


	// group 7 : (ausgaenge) 89-98

	{"LED1 Bitmaske ","Out1 Bitmask  ","Uitg1 Bitpatr."},
	{"     Timing   ","Out1 Timing   ","Uitg1 Timing  "},
	{"     sofort an","Activ         ","Direct aan    "},
	{"     n.m.Motor","Act. wi. Motor","Akt. motor uit"},
#if defined MKVERSION090b
	{"mit WP-Event  ","comb. WP-Event","comb. WP-Event"},
	{"AutoTr. m/Poti","AutoTr. m/poti","AutoTr. m/poti"},
#elif defined MKVERSION090e || defined MKVERSION090h || defined MKVERSION091a || defined MKVERSION091f || defined MKVERSION201a || defined MKVERSION201f
        {"mit WP-Event  ","comb. WP-Event","comb. WP-Event"},
        {"AutoTr. m/Poti","AutoTr. m/poti","AutoTr. m/poti"},
#elif defined MKVERSION088n
#else
#error "Fehlende Definition"
#endif
	{"LED2 Bitmaske ","Out2 Bitmask  ","Uitg2 Bitpatr."},
	{"     Timing   ","Out2 Timing   ","Uitg2 Timing  "},
	{"     sofort an","Activ         ","Direct aan    "},
	{"     n.m.Motor","Act. wi. Motor","Akt. motor uit"},
	{"Out1 Vmin.Warn","Out1 undervolt","Uitg1 ondersp."},
	{"Out2 Vmin.Warn","Out2 undervolt","Uitg2 ondersp."},


	// group 8 : (verschiedenes) 99-11

	{"Min. Gas      ","min. throttle ","Minimaal gas  "},
	{"Max. Gas      ","max. throttle ","Maximaal gas  "},
	{"Kompasswirkung","compass effect","Kompas effect "},
#if defined MKVERSION201f
	{"Kompassoffset ","compass offset","Kompas offset "},
	{"Dis.declin.cal","Dis.declin.cal","Dis.declin.cal"},
#else
#error "Fehlende Definition"
#endif
	{"Carefree St.  ","Carefree Ctrl ","Carefree Ctrl "},
	{"Teachable Care","Teachable Care","Teachable Care"},
	{"Unterspannung ","undervoltage  ","Onderspanning "},
#if defined MKVERSION201f
	{"Autoland. Volt","autoland volt ","autoland volt "},
#else
#error "Fehlende Definition"
#endif
	{"Volt Referenz ","Volt Referenz ","Ref. spanning "},
	{"Not Gas Zeit  ","Emerg.Thr.Time","Nood gas tijd "},
	{"Not Gas       ","Emerg.Throttle","Nood gas      "},
	{"Fails. CH Time","Fails. CH Time","Fails. CH Tijd"},
        {"Fails. Channel","Fails. Channel","Fails. Channel"}, //FC 0.87
        {"k.Summer o Sen","n beep act TX ","Geen beep z TX"}, // Pos Change FC0.87
        {"Vario fail Alt","Vario fail Alt","Vario fail Alt"}, //FC 0.87
	{"Compass Error ","Compass Error ","Kompas Error  "},
	{"k.Start o.SD-K","n st. wtho SD ","G.start z. SD "}, //FC 0.87
	{"k.Start o.GPS ","n st. wtho GPS","G.start z. GPS"}, //FC 0.88L

	// group 9 : (gyro) 114-126

	{"Gyro P        ","Gyro P        ","Gyro P        "},
	{"Gyro I        ","Gyro I        ","Gyro I        "},
	{"Gyro D        ","Gyro D        ","Gyro D        "},
	{"Gier P        ","Lacet P       ","Gier P        "},
	{"Gier I        ","Lacet I       ","Gier I        "},
	{"Dynamische St.","dynamic stabi.","Dynamis. stab."},
	{"Drehratenbeg. ","RotRate limit.","Toerental lim."},
	{"ACC/Gyro Fak. ","ACC/Gyro Fact ","ACC/Gyro Fact "},
	{"ACC/Gyro Komp.","Comp ACC/Gyro ","Comp ACC/Gyro "},
	{"Hauptregler I ","Main I        ","Hoofdregel. I "},
	{"Drifkompensat.","drift Compens.","Drift compens."},
	{"Gyro stab.    ","Gyro stability","Gyro stabilit."},
	{"Motor smooth  ","Motor smooth  ","Motor smooth  "},


	// group 10: (benutzer) 127-134

	{"Parameter 1   ","Parameter 1   ","Parameter 1   "},
	{"Parameter 2   ","Parameter 2   ","Parameter 2   "},
	{"Parameter 3   ","Parameter 3   ","Parameter 3   "},
	{"Parameter 4   ","Parameter 4   ","Parameter 4   "},
	{"Parameter 5   ","Parameter 5   ","Parameter 5   "},
	{"Parameter 6   ","Parameter 6   ","Parameter 6   "},
	{"Parameter 7   ","Parameter 7   ","Parameter 7   "},
	{"Parameter 8   ","Parameter 8   ","Parameter 8   "},


	// group 11: (achskopplung) 135-13

	{"Achs(e.)koppl.","(De)Coupl Axes","As koppeling  "},
	{"Gier pos. Kopp","Retroac lacet ","Gier pos. kop."},
	{"Nick/Roll Kopp","Retro roul/tan","Nick/Roll kop."},
	{"Gier Korrektur","Correct lacet ","Gier correctie"},


	// group 12: (mixer) 139

	{"Orientierung  ","Orientierung  ","Orientatie    "},


	// group 13 (easy) 140-150

	{"Hhenregelung ","Altitude Ctrl ","Hoogte Contr. "},
	{"Sollhhe      ","Setpoint      ","Gewenst.hoogte"},
	{"Stick Neutr. P","stick neutr. P","Stick neutr. P"},
	{"GPS           ","enable GPS    ","Enable GPS    "},
	{"GPS Modus St. ","GPS mode contr","GPS mode contr"},
	{"Dynamic PH    ","Dynamic PH    ","Dynamic PH    "},
	{"CH Hhe       ","CH High       ","CH hoogte     "},
	{"Carefree St.  ","Carefree Ctrl ","Carefree Ctrl "},
	{"Teachable Care","Teachable Care","Teachable Care"},
	{"Motor Sich.Sch","Mot.Safety Sw.","Mot.saf.schak."},
	{"Orientierung  ","Orientation   ","Orientatie    "},

};

